<?php
/**
 *
 * @category        snippet
 * @package         Force password change
 * @author          Ruud Eisinga
 * @link			http://www.dev4me.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.3.6 and higher
 * @version         1.0.0
 * @lastmodified    December 18, 2015
 */
 
if(defined('WB_PATH') == false) {
	exit("Cannot access this file directly"); 
}
require_once(WB_PATH .'/modules/forcepass/languages/EN.php');
if(file_exists(WB_PATH .'/modules/forcepass/languages/' .LANGUAGE .'.php')) {
	require_once(WB_PATH .'/modules/forcepass/languages/' .LANGUAGE .'.php');
}
$error = '';
$success = '';
if(isset($_POST['change_pass'])) {

	$iMinPassLength = 6;

	$sCurrentPassword = $wb->get_post('curr_pass');
	$sCurrentPassword = (is_null($sCurrentPassword) ? '' : $sCurrentPassword);

	$sNewPassword = $wb->get_post('new_pass');
	$sNewPassword = is_null($sNewPassword) ? '' : $sNewPassword;

	$sNewPasswordRetyped = $wb->get_post('rep_pass');
	$sNewPasswordRetyped= is_null($sNewPasswordRetyped) ? '' : $sNewPasswordRetyped;
	
	$uid = $wb->get_user_id();
	$sql  = "SELECT `password` FROM `".TABLE_PREFIX."users` WHERE `user_id` = '$uid'";
	if (md5($sCurrentPassword) != $database->get_one($sql)) {
		$error = $fpc['CURRENT_PASSWORD_INCORRECT'];
	}else {
		if(strlen($sNewPassword) < $iMinPassLength) {
			$error = $fpc['USERS_PASSWORD_TOO_SHORT'];
		}else {
			if($sNewPassword != $sNewPasswordRetyped) {
				$error = $fpc['USERS_PASSWORD_MISMATCH'];
			}else {
				$pattern = '/[^'.$wb->password_chars.']/';
				if (preg_match($pattern, $sNewPassword)) {
					$error = $fpc['INVALID_CHARS'];
				} else {
					$sPwHashNew = md5($sNewPassword);
					$sql  = "UPDATE `".TABLE_PREFIX."users` SET `password`='$sPwHashNew' WHERE `user_id`='$uid'";
					if ($database->query($sql)) {
						$success = $fpc['PASSWORD_CHANGED'];
					}else {
						$error = $database->get_error();
					}
				}
			}
		}
	}
}

?>
<link href="<?php echo WB_URL ?>/modules/forcepass/style.css" rel="stylesheet" type="text/css" media="screen" />
<?php 
if($error) $error = '<div class="pref-error">'.$error.'</div>';

if($success) {
	?>
	<div class="pref-box">
		<div class="pref-header">
			<div class="pref-success"><?php echo $success ?></div>
		</div>
	</div>
	<?php 
	return;
} 
?>
<form method="post">
<div class="pref-box">
	<?php if(!isset($_SESSION['force_pass_done'])) { ?>
	<div class="pref-header"><?php echo $fpc['FORCE_CHANGE_PASSWORD'] ?></div>
	<?php } else { ?>
	<div class="pref-header"><?php echo $fpc['CHANGE_PASSWORD'] ?></div>
	<?php }  ?>
	<?php echo $error ?>
	<div class="pref-row">
		<span class="pref-title"><?php echo $fpc['CURRENT_PASSWORD'] ?>: </span>
		<span class="pref-input"><input  type="password" name="curr_pass" value="" /></span>
	</div>
	<div class="pref-row">
		<span class="pref-title"><?php echo $fpc['NEW_PASSWORD'] ?>: </span>
		<span class="pref-input"><input  type="password" name="new_pass" value="" /></span>
	</div>
	<div class="pref-row">
		<span class="pref-title"><?php echo $fpc['RETYPE_NEW_PASSWORD'] ?>: </span>
		<span class="pref-input"><input  type="password" name="rep_pass" value="" /></span>
	</div>
	<div class="pref-row">
		<span class="pref-submit"><input type="submit" name="change_pass" value="<?php echo $fpc['SUBMIT'] ?>" /></span>
	</div>
</div>
</form>
